<template lang="pug">
    .col-12.col-12-small
        form(method='post' action='#')
            .row.gtr-uniform.gtr-50
                .col-12
                    textarea#message(name='message' :placeholder="placeholder" rows='4' v-model="body" :readonly="inProgress" )
        ul.actions
            li
                input(type='button' value='Send Message' @click="sendReply()" :disabled="inProgress").primary
            li(v-if="showCancel")
                input(type='button' value='Cancel' @click="cancel()" :disabled="inProgress")

</template>

<script>
    import Vue from 'vue';
    import Vuex from 'vuex';
    import CommentsService from "../../services/CommentsService";

    export default Vue.component('reply-form', {
        props: {
            parent_author: {
                type: String,
                required: true
            },
            parent_permlink: {
                type: String,
                required: true
            },
            showCancel: {
                type: Boolean,
                required: true,
                default: true
            }
        },

        data() {
            return {
                body: '',
                inProgress: false
            }
        },


        computed: {
            username() {
                return this.$store.state.sso.username;
            },
            placeholder() {
                return `Writing as @${this.username}`
            },
            token() {
                return this.$store.state.sso.token;
            }
        },

        methods: {
            sendReply() {
                this.inProgress = true;
                return CommentsService.sendComment(this.$props.parent_author, this.$props.parent_permlink, 'test-title', this.body, this.token )
                    .then(response => {
                        const { data } = response;
                        this.success(data);
                    }).catch((error) => {
                        this.inProgress = false;
                        console.log(error);
                    })
            },
            cancel() {
                this.body = '';
                this.$emit('cancel')
            },
            success(data) {
                this.inProgress = false;
                this.body = '';
                this.$emit('success', data);
            }
        }
    })

</script>
